Subject: Re: AW: [PATCH] net/can/mscan: Enable interrupts when all TX buffers are occupied to get notified when they are available again

From: Wolfgang Grandegger <[email-masked]>
Date: Mon, 28 Nov 2011 15:08:08 +0100

On 11/28/2011 02:59 PM, Mosler, Martin wrote:
>>> When all TX buffers of the mscan are occupied the network layer is told to stop sending further packets. However the TX interrupts are not enabled and therefore the driver has no chance to tell the network layer when it is ready to accept further packets.
>>>
>>> Signed-off-by: Martin Mosler <[email-masked]>
>>>
>>> --- linux-2.6/drivers/net/can/mscan/mscan.c.orig    2011-11-28 13:54:29.547850661 +0100
>>> +++ linux-2.6/drivers/net/can/mscan/mscan.c 2011-11-28 13:55:52.427849601 +0100
>>> @@ -214,6 +214,7 @@ static netdev_tx_t mscan_start_xmit(stru
>>>     case 0:
>>>         netif_stop_queue(dev);
>>>         dev_err(dev->dev.parent, "Tx Ring full when queue awake!\n");
>>> +       out_8(&regs->cantier, priv->tx_active);
>>>         return NETDEV_TX_BUSY;
>>>     case 1:
>>>         /*
>>
>> Hm, did you see the error message. Actually, it should never happen, IIRC.
>>
>> Wolfgang.
> 
> It is in fact a very rare condition, but it was triggered during testing when pulling CAN-HI and CAN-LO lines
> to GND and VCC in various combinations to verify how the system is recovering. I am working with a MPC5125 
> if this is valuable information. (This was only one issue I ran into, I had to do other modifications for other 
> issues as well, but I think they are chip specific, I'll share them in a separate thread if you like).

Sounds like a problem with bus-off recovery. The software has restarted
the queue but the TX objects are still active. How do you handle
bus-offs? Manually? restart-ms = ?

Would be great if you post patches for your other issues.

Wolfgang.